package peer

import (
    "github.com/iotaledger/goshimmer/packages/identity"
)

const (
    MARSHALLED_PUBLIC_KEY_START            = 0
    MARSHALLED_ADDRESS_TYPE_START          = MARSHALLED_PUBLIC_KEY_END
    MARSHALLED_ADDRESS_START               = MARSHALLED_ADDRESS_TYPE_END
    MARSHALLED_PEERING_PROTOCOL_TYPE_START = MARSHALLED_ADDRESS_END
    MARSHALLED_PEERING_PORT_START          = MARSHALLED_PEERING_PROTOCOL_TYPE_END
    MARSHALLED_GOSSIP_PROTOCOL_TYPE_START  = MARSHALLED_PEERING_PORT_END
    MARSHALLED_GOSSIP_PORT_START           = MARSHALLED_GOSSIP_PROTOCOL_TYPE_END

    MARSHALLED_PUBLIC_KEY_END            = MARSHALLED_PUBLIC_KEY_START + MARSHALLED_PUBLIC_KEY_SIZE
    MARSHALLED_ADDRESS_TYPE_END          = MARSHALLED_ADDRESS_TYPE_START + MARSHALLED_ADDRESS_TYPE_SIZE
    MARSHALLED_ADDRESS_END               = MARSHALLED_ADDRESS_START + MARSHALLED_ADDRESS_SIZE
    MARSHALLED_PEERING_PROTOCOL_TYPE_END = MARSHALLED_PEERING_PROTOCOL_TYPE_START + MARSHALLED_PEERING_PROTOCOL_TYPE_SIZE
    MARSHALLED_PEERING_PORT_END          = MARSHALLED_PEERING_PORT_START + MARSHALLED_PEERING_PORT_SIZE
    MARSHALLED_GOSSIP_PROTOCOL_TYPE_END  = MARSHALLED_GOSSIP_PROTOCOL_TYPE_START + MARSHALLED_GOSSIP_PROTOCOL_TYPE_SIZE
    MARSHALLED_GOSSIP_PORT_END           = MARSHALLED_GOSSIP_PORT_START + MARSHALLED_GOSSIP_PORT_SIZE

    MARSHALLED_PUBLIC_KEY_SIZE            = identity.PUBLIC_KEY_BYTE_LENGTH
    MARSHALLED_ADDRESS_TYPE_SIZE          = 1
    MARSHALLED_ADDRESS_SIZE               = 16
    MARSHALLED_PEERING_PROTOCOL_TYPE_SIZE = 1
    MARSHALLED_PEERING_PORT_SIZE          = 2
    MARSHALLED_GOSSIP_PROTOCOL_TYPE_SIZE  = 1
    MARSHALLED_GOSSIP_PORT_SIZE           = 2
    MARSHALLED_TOTAL_SIZE                 = MARSHALLED_GOSSIP_PORT_END
)
